{% extends "base.html" %}
{%- import "common/macros/generic.html" as mg -%}


{% block head %}
    {% assets
        filters="cssrewrite, cssmin",
        output="compressed/datatables.css",
        "css/plugins/jquery.datatables.bootstrap4.min.css",
        "css/plugins/jquery.datatables.utils.css"
    %}
        {{ mg.async_css(ASSET_URL) }}
    {% endassets %}
    {% block sub_head %}{% endblock %}
{% endblock %}


{% block content_main %}
    {% set module_name = request.mod|normalize|title %}
    <div class="card">
        <div class="card-header">
            <div class="row">
                <div class="col-12 col-md-6 col-xl-7">
                    <nav aria-label="breadcrumb">
                        <ol class="breadcrumb bg-transparent mb-1 mb-md-0 py-1 py-md-0 pl-1">
                            <li class="breadcrumb-item"><a href="{{ url_for('.index') }}">{{ module_name }}</a></li>
                            <li class="breadcrumb-item"><a href="{{ url_for('.edit', _id=record._id) }}">{{ record.item_code }}</a></li>
                            <li class="breadcrumb-item active"> Stock Card</li>
                        </ol>
                    </nav>
                </div>
                <div class="col-12 col-md-6 col-xl-5 text-right">
                    <div class="row">
                        <div class="col">
                            <a href="{{ url_for('.issue_tag', _id=record._id, from='stock_card') }}" class="btn btn-warning btn-sm btn-block my-2 my-md-1"><i class="fa fa-fw fa-plus"></i> Create Issue Tag</a>
                        </div>
                        <div class="col">
                            <a href="{% if redirect_from == 'details' %}{{ url_for('.edit', _id=record._id) }}{% else %}{{ url_for('.index') }}{% endif %}" class="btn btn-danger btn-sm btn-block my-2 my-md-1"><i class="fa fa-fw fa-arrow-left"></i> Go Back</a>
                        </div>
                    </div>
                </div>
            </div>
            <h4 class="card-title mt-1 mt-md-0"> Stock Card</h4>
        </div>
        <div class="card-body">
            <div class="row">
                <div class="col-12 col-md-6">
                    <div class="row">
                        <div class="col-12">
                            <div class="form-group">
                                <label>{{ "item_code"|normalize|title }}</label>
                                <input type="text" class="form-control" value="{{ record.item_code }}" readonly />
                            </div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-12">
                            <div class="form-group">
                                <label>{{ "description"|normalize|title }}</label>
                                <input type="text" class="form-control" value="{{ record.description }}" readonly />
                            </div>
                        </div>
                    </div>
                </div>
                <div class="col-12 col-md-6">
                    <div class="row">
                        <div class="col-12">
                            <div class="form-group">
                                <label>{{ "current_stock_on_hand"|normalize|title }}</label>
                                <input type="text" class="form-control" value="{{ record.stock_on_hand }}" readonly />
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-12">
                    <table class="table table-striped table-hover table-bordered">
                        <thead>
                            <tr>
                                {% for column in STOCK_CARD_DATA_COLUMNS %}
                                    {% if column.hidden is undefined %}
                                        <th>{{ column.label }}</th>
                                    {% endif %}
                                {% endfor %}
                            </tr>
                        </thead>
                    </table>
                </div>
            </div>
        </div>
    </div>
{% endblock %}


{% block scripts %}
    {% assets
        filters="rjsmin",
        output="compressed/datatables.js",
        "js/plugins/jquery.datatables.min.js",
        "js/plugins/jquery.datatables.bootstrap4.min.js"
    %}
        {{ mg.js(ASSET_URL) }}
    {% endassets %}
    <script>
        merge_objects($dom, {
            tables: {
                stock_card: $('table.table')
            },
            datatables: {}
        });

        {# SECTION: Datatable #}
        let datatable_options = {
            dom: 'rt<"row"<"col-12 col-md-4 col-xl-3"l><"col-12 col-md-8 col-xl-9"p>><"row"<"col-12 text-center"i>>',
            order: [[0, 'desc']],
            autoWidth: false,
            responsive: true,
            stateSave: true,
            serverSide: true,
            deferLoading: true,
            lengthMenu: [[25, 50, 100, -1], ['25 Records', '50 Records', '100 Records', 'All Records']],
            ajax: {
                url: '{{ url_for(".load_stock_card", _id=record._id) }}',
                type: 'POST',
                dataType: 'json'
            },
            columns: [
                {
                    data: 'date_created'
                },
                {
                    data: 'type',
                    render: function(data) {
                        switch (data) {
                            case 'issue_tag':
                                return 'Actual Count';
                            default:
                                return data.normalize().titleCase();
                        }
                    }
                    // orderable: false
                },
                {
                    data: 'reference',
                    className: 'd-none d-sm-none d-md-table-cell',
                    render: function(data, type, row) {
                        if (data != '') {
                            return '<a href="{0}">{1}</a>'.format(data.link, data.label);
                            return data.label;
                        }
                        else {
                            return '';
                        }
                    },
                    orderable: false
                },
                {
                    data: 'location',
                    render: function(data) {
                        return (data == null) ? '--' : data;
                    },
                    orderable: false
                },
                {
                    data: 'cumulative_quantity',
                    render: function(data) {
                        return (data == 0) ? '--' : (data > 0) ? data : '--'.format(data);
                    },
                    orderable: false
                },
                {
                    data: 'cumulative_quantity',
                    render: function(data) {
                        return (data == 0) ? '--' : (data < 0) ? data : '--'.format(data);
                    },
                    orderable: false
                },
                {
                    data: 'aggregate_quantity',
                    orderable: false
                },
                {
                    data: 'price_per_unit',
                    render: function(data) {
                        if (isDefined(data)) {
                            return (data == 0) ? '--' : (data > 0) ? data : '({0})'.format(data);
                        } else {
                            return '--';
                        }
                    },
                    orderable: false
                },
                {
                    data: 'created_by',
                    orderable: false
                },
                {
                    data: 'expiry_date',
                    className: 'd-none d-sm-none d-md-table-cell',
                    render: function(data) {
                        return (data == null) ? '--' : data;
                    },
                    orderable: false
                },
                {
                    data: 'manufacturing_date',
                    className: 'd-none d-sm-none d-md-table-cell',
                    render: function(data) {
                        return (data == null) ? '--' : data;
                    },
                    orderable: false
                },
            ],
            rowId: '_id',
            initComplete: function() {
                $dom.document.find('.dataTables_info').addClass('text-muted');
            },
            preDrawCallback: function() {

            },
            drawCallback: function() {

            }
        }
        $dom.datatables.stock_card = $dom.tables.stock_card.DataTable(datatable_options);

        $dom.datatables.stock_card.reload = function(search) {
            $dom.datatables.stock_card.ajax.reload(function() {
                if (!isDefined(search)) {
                }
            });
        }
        {# END: Datatable #}

        $dom.document.ready(function() {
            $dom.datatables.stock_card.reload();
        });
    </script>
{% endblock %}
